# spiegel.tcl v1.0 by domsen <domsen@domsen.org> (c)2oo3
#
# comments? bugs? ideas? requests? money? beer? 
# plz mail me or visit my homepage @ www.domsen.org
# also check out www.uid-zero.de
#
# das tcl  liest die  spiegel.de news aus und gibt  sie  wieder, gleich mit dem
# link  zum eigentlichen  artikel.  per trigger  lassen sich auch die letzten X
# news von hand auslesen.
#
#
# v1.0 - erste version, requested by ^cons^
#
# spiegeltrigger - der trigger auf den der bot reagiert (public und message)
# spiegellimit - maximum der news die auf befehl geposted werden
# spiegelnewspost  - 1 fr newsposting, 0 fr keines
# spiegelchans  - die  chans in  denen das tcl aktiv  ist, "" fr alle
# spiegelnewspostlimit - maximum der news die geposted werden
# isspiegelhub  - legt fest ob der bot newshub ist oder nicht
# spiegelleafs  - die nicks der leafbots auf denen das leaf tcl luft
#
####### config ######################

set spiegeltrigger ".spiegel"
set spiegelchans ""
set spiegellimit "10"
set spiegelnewspostlimit "3"
set spiegelnewspost "1"
set isspiegelhub ""
set spiegelleafs ""

####### ende der config #############

bind msg - $spiegeltrigger msg_spiegel
bind pub - $spiegeltrigger pub_spiegel
bind time - "?0 * * * *" spiegelcheck

proc sendspiegelnews { arg } {
global spiegelleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $spiegelleafs] [string tolower $bot]] != -1)} {
putbot $bot "spiegel: $arg"
}}}

proc shrink { calc number string start bl} { return [expr [string first "$string" $bl $start] $calc $number] }

proc html { text } {
regsub -all "&uuml;" $text "" text
regsub -all "&ouml;" $text "" text
regsub -all "&auml;" $text "" text
regsub -all "&Uuml;" $text "" text
regsub -all "&Ouml;" $text "" text
regsub -all "&Auml;" $text "" text
regsub -all "&szlig;" $text "" text
regsub -all "&quot;" $text "\"" text
return $text
}

proc spiegelcheck {nick uhost hand chan arg} {
global spiegelchans spiegelnewspost isspiegelhub spiegelnewspostlimit
set counter 0
if {$spiegelnewspost == 1 } {
putlog "spiegel: suche nach neuer newsline"
set spiegellastnews "none"
if {[file exists spiegel.hdl]} {
set temp [open "spiegel.hdl" r]
set spiegellastnews "[gets $temp]"
if {$spiegellastnews == "" } { set spiegellastnews "none"}
close $temp
}
set temp [open "spiegel.hdl" w+]
if {[catch {set sock [socket www.spiegel.de 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /schlagzeilen/ HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: www.spiegel.de"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first ")</font></nobr><br>" $bl] != -1} {
set link "www.spiegel.de[string range $bl 9 [shrink - 1 "\">" 0 $bl]]"
regsub -all "<font color=\"black\">" [string range $bl [shrink + 2 "\">" 0 $bl] [shrink - 1 "</font>" 0 $bl]] "" newsline
puts $temp "[html $newsline] <$link>"
}}}
close $sock ; close $temp
if {$spiegellastnews == "none" } { putlog "spiegel: headlinefile created" ; return 0 }
set temp [open "spiegel.hdl" r]
while { [eof $temp] != 1 } {
set spiegelneunews [gets $temp]
if {($spiegellastnews == $spiegelneunews) || ($counter == $spiegelnewspostlimit)} {close $temp; return 0 }
incr counter
if { $isspiegelhub == "1" } { sendspiegelnews $spiegelneunews }
foreach chan [channels] {
if {$spiegelchans == "" } { putserv "privmsg $chan :(neue spiegel newsline) $spiegelneunews" }
if {$spiegelchans != "" } {
if {([lsearch -exact [string tolower $spiegelchans] [string tolower $chan]] != -1) || ($spiegelchans == "")} {putserv "privmsg $chan :(neue spiegel newsline) $spiegelneunews"}
}
}}}}


proc spiegelnews {target limit} {
if {[catch {set sock [socket www.spiegel.de 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /schlagzeilen/ HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: www.spiegel.de"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first ")</font></nobr><br>" $bl] != -1} {
set link "www.spiegel.de[string range $bl 9 [shrink - 1 "\">" 0 $bl]]"
regsub -all "<font color=\"black\">" [string range $bl [shrink + 2 "\">" 0 $bl] [shrink - 1 "</font>" 0 $bl]] "" newsline
putserv "privmsg $target :[incr counter] [html $newsline] <$link>"
}
if {$counter == $limit} {close $sock ; return 0 }
}}}

proc msg_spiegel { nick uhost hand arg } { global spiegellimit ; spiegelnews $nick $spiegellimit }
proc pub_spiegel { nick uhost hand chan arg } { global spiegelchans spiegellimit ; if {([lsearch -exact [string tolower $spiegelchans] [string tolower $chan]] != -1) || ($spiegelchans == "")} { spiegelnews $nick $spiegellimit }}

putlog "*** spiegel.tcl v1.0 by domsen <domsen@domsen.org> succesfully loaded"

#[EOF]